% Generated by roxygen2 (4.0.1): do not edit by hand
\name{vcgPlyRead}
\alias{vcgPlyRead}
\title{Import ascii or binary PLY files.}
\usage{
vcgPlyRead(file, updateNormals = TRUE, clean = TRUE)
}
\arguments{
\item{file}{character: file to be read.}

\item{updateNormals}{logical: if TRUE and the imported file contais faces,
vertex normals will be (re)calculated.}

\item{clean}{logical: if TRUE, duplicated and unreference vertices will be
removed.}
}
\value{
Object of class "mesh3d"

with:

\item{vb }{3 x n matrix containing n vertices as homolougous coordinates}
\item{normals }{3 x n matrix containing vertex normals}
\item{it }{3 x m integer matrix containing vertex indices forming triangular faces}
\item{material$color }{Per vertex colors if specified in the imported file}
}
\description{
Reads Polygon File Format (PLY) files and stores the results in an object of
class "mesh3d" - momentarily only triangular meshes are supported.
}
\note{
from version 0.8 on this is only a wrapper for vcgImport (to avoid API breaking).
}
\author{
Stefan Schlager
}
\seealso{
\code{\link{vcgSmooth}},
}
\keyword{~kwd1}
\keyword{~kwd2}

